<template>
  <q-page>
    <!-- Hero/Form -->
    <div class="hero" style="background:#222222">
      <div class="inner-page text-white q-pa-xl">
        <div class="hero-heading text-center q-mb-lg">
          <span class="text-italic">
            Bitcoin<span class="text-primary">Cash</span>
          </span>
          Paper Terminals
        </div>
        <p class="hero-subheading">
          A quick, easy, low-cost, low-maintenance way to start accepting BitcoinCash.
        </p>
        <p class="hero-explainer-heading">How it works</p>
        <p class="hero-explainer">
          A terminal is printed and configured by scanning the Terminal QR Code for the first time.
        </p>
        <div class="text-center q-mb-xl">
          <q-btn label="Click here to print a Terminal" color="primary" icon="point_of_sale" to="print" />
        </div>
        <div class="row q-col-gutter-xl text-center q-mb-xl">
          <div class="col-12 col-md-4">
            <div class="hero-explainer" >Then, when a Customer wants to pay using Bitcoin Cash, the staff member scans the terminal QR Code using their <strong>own</strong> phone and sets the amount due.</div>
            <img src="~assets/merchant-example.png" />
          </div>
          <div class="col-12 col-md-4">
            <div class="hero-explainer">Customer then opens their Bitcoin Cash Wallet Application, scans the "Scan to Pay" QR Code on the counter and confirms the payment.</div>
            <img src="~assets/customer-example.png" />
          </div>
          <div class="col-12 col-md-4">
            <div class="hero-explainer">The Terminal will then show that the Transaction and the amount requested has been received successfully along with a nice "ding!" noise.</div>
            <img src="~assets/merchant-received-example.png" />
          </div>
        </div>
      </div>
    </div>
    <div class="inner-page">
      <div class="page-segment">
        <h2>Why?</h2>

        <p>Bitcoin Cash merchant adoption is going great. However, there can be a few hiccups in places that are listed as accepting Bitcoin Cash, but have low customer throughput:</p>

        <ol>
          <li>Infrequent BCH payments can lead to the Android Device that is being used as a Payment Terminal being neglected (not charged, not connected to WiFi, not turned on, etc).</li>
          <li>High employee turnover can mean that many of the staff are unsure as to how to use the Payment Terminal (or don't know where it is).</li>
        </ol>

        <p>As an experimental alternative, as opposed to a merchant using a dedicated Payment Terminal Device, we might fare better allowing staff to (simply and easily) use their own phone for accepting BCH Payments.</p>

        <p>One way in which we can do this is by having two QR Codes that we simply print on Sticky Paper:</p>

        <ol>
          <li>A QR Code that is staff-facing that can be scanned to open a WebApp that allows the staff to set the amount that is due.</li>

          <li>A QR Code that is customer-facing that can then be scanned by their Wallet App to pay that amount.</li>
        </ol>
      </div>

      <div class="page-segment">
        <h2>For Example</h2>

        <QRCodesComponent class="q-mb-lg"/>

        <p>Such a setup would have a few benefits for merchants and those spreading adoption:</p>

        <ol>
          <li>For merchants, there is no dedicated Payment Terminal device that the merchant needs to maintain: Staff can simply use their own phone and open the Terminal in their phone browser (no need to install an app).</li>

          <li>For those spreading adoption, on-boarding BCH Merchants becomes cheap. There is no need to supply a dedicated terminal device - just a sheet of sticky-paper with two QR Codes.</li>
        </ol>

        <p>In this PoC, the interface for merchants has been kept simple so that no training should be required and the process is (hopefully) friction-less.</p>
      </div>

      <div class="page-segment">
        <h2>Constraints</h2>

        <p>This dual QR Code approach does require the customer's wallet to support either the BIP70 or JPP Payment Protocols. This means that some wallets, unfortunately, will not be properly supported (see boldened fallback text below).</p>

        <p>This has been tested to work with:</p>

        <ol>
          <li>Bitcoin.Com Wallet</li>

          <li>Electron Cash</li>
        </ol>

        <p>... but any wallet that properly supports BIP70/JPP should work and the intent is to support any future Payment Protocols.</p>

        <p><strong>As a fallback, there is a "Scan To Pay QR not working?" button that will present an address/amount  monitored BIP21 QR Code on the Cashier's phone for the customer to scan. This, however, is only recommended as a fallback for security reasons (Cashier could easily present their own QR Code and, hence, pocket the funds).</strong></p>
      </div>

      <div class="page-segment">
        <h2>Adoption Potential</h2>

        <p>There may be a few additional benefits to this setup from an adoption point of view:</p>

        <ol>
          <li>
            On the flip-side of  using a Payment Protocol (like BIP70 or JPP), there may in future be opportunity to provide some incentive to spread adoption as it would be possible to cut a small fee on-top of each BCH purchase for each merchant on-boarded. Thus, we could incentivize those spreading adoption.<br/>
            <em>(For anyone wishing to attempt this, the code is open-source and I would be more than happy to assist.)</em>
          </li>

          <li>As an adoption strategy, due to this system being operable with paper-only, bulk-mailing adoption campaigns where these terminals are mailed to potential businesses (with setup instructions) becomes feasible.</li>
        </ol>
      </div>

      <div class="page-segment">
        <h2>Additional Considerations</h2>

        <p>The feasibility of the following would have to be evaluated.</p>

        <ol>
          <li>In some cases, a merchant may also require purchases to be tracked internally (for inventory purposes). It may be possible to allow a guide to be written and displayed to the staff upon first scanning the Terminal QR Code to ease this process (alternately, this could just be printed on the Terminal QR Code sticker itself).</li>

          <li>Streamlining the above, there might be the possibility of a Merchant's existing PoS system integrating directly with ScanToPay such that the Staff no longer needs to scan a QR Code - they can just input the amount in their existing PoS (which could interact with the ScanToPay API) and instruct the customer to scan the Payment QR Code.</li>
        </ol>
      </div>

      <div class="page-segment">
        <h2>Security</h2>

        <p>Although, not ideal, it is not currently possible to change the Destination/Receiving Address after a terminal has been initially configured. This is to prevent a malicious employee from changing the Receiving Address to their own. However, there are still some things to keep in mind:</p>

        <ol>
          <li>A malicious employee (or third-party) can perform a "griefing attack" if they discover the Merchant URL and can set the amount due remotely. In this event, a customer could be presented an invoice that is incorrect, but the malicious party still cannot steal the funds to themselves (as the address will always remain the address that was initially configured). Thus, there should be little incentive in doing this, except to be a nuisance.</li>

          <li>An malicious employee could try to replace the Payment QR code with their own. This would be like an employee "stealing money from the til" so we do not try to explicitly guard against this. However, to minimize risk and at least make this noticeable, these QR Codes could have a space for the owner to sign their signature (with pen) which should make it obvious if this has taken place. Another option is to physically secure the QR Code such that this cannot happen easily.</li>
        </ol>

        <p>It would be ideal to have a mechanism for the Terminal configurations to be updated, but I do not believe a password is ideal. There are many naive store owners that may set the password to the same as all other passwords used by staff (or to something that is easily guessable), thus if anyone has suggestions that will NOT significantly hinder UX flow, please let me know. Another reason that this is useful is to prevent the griefing attack mentioned in point 1 above. If this happens to a merchant the simplest remedy would be to add a password hashbang (i.e. "#pwd=1234abcd") and then allow the Merchant to reprint the Merchant QR Code only (with this new password included in the URL).</p>
        <p>One such approach might be to collect Email Address upon Terminal setup and then require Email Confirmation upon any changes. However, the trade-off here is that it's an additional piece of (private) information that the Merchant would have to provide.</p>
      </div>

      <div class="page-segment">
        <h2>Final Note</h2>

        <p>This release is intended to gather feedback on the concept/flow and how this could be made easier/more useful.</p>

        <p>Please leave feedback on the <a href="https://read.cash/@jimtendo/scantopaycash-ca4fa11c" target="_blank">Read.Cash Article</a> or feel free to contact me directly on <a href="https://t.me/jimtendo" target="_blank">@jimtendo on Telegram</a>.</p>
      </div>
    </div>
  </q-page>
</template>

<script setup lang="ts">
import QRCodesComponent from '../components/QRCodesComponent.vue'
</script>

<style lang="scss">
  .hero-explainer-heading {
    text-align: center;
    font-size: 2em;
    margin-bottom: 0.5em;
    font-family: 'Gloria Hallelujah', cursive;
    color: $primary;
  }

  .example-heading {
    text-align: center;
    font-size: 1.3em;
    margin-bottom: 1em;
    font-family: 'Gloria Hallelujah', cursive;
  }

  .examples img {
    max-width: 100%;
    padding: 20px;
  }

  .example-desc {
    font-size: 0.9em;
    padding: 0px 20px 0px 20px;
  }

  .code {
    background: #333;
    color: #fff;
    padding: 10px;
    font-size: 0.8em;
  }
</style>
